package com.banesco.module.correspondence.infrastructure.client;

import com.banesco.common.application.usecase.HttpClientUseCase;
import com.banesco.common.domain.exception.HttpApiResponseException;
import com.banesco.common.domain.exception.HttpStatusCodeException;
import com.banesco.common.domain.model.ApiResponse;
import com.banesco.common.domain.model.DomainConfig;
import com.banesco.common.domain.model.HttpRequest;
import com.banesco.common.infrastructure.config.RestClientConfig;
import com.banesco.module.correspondence.application.usecase.DomainUseCase;
import com.banesco.module.correspondence.domain.dto.request.CorrespondenceRequest;
import jakarta.enterprise.context.ApplicationScoped;
import jakarta.inject.Inject;
import lombok.extern.slf4j.Slf4j;

@Slf4j
@ApplicationScoped
public class DomCorrespondenceClient implements DomainUseCase {
    private final HttpClientUseCase httpClientUseCase;
    private final DomainConfig domainConfig;

    @Inject
    public DomCorrespondenceClient(
        HttpClientUseCase httpClientUseCase,
        RestClientConfig restClientConfig
    ) {
        this.httpClientUseCase = httpClientUseCase;
        this.domainConfig = restClientConfig.getDomServiceIssueConfig();
        log.info("Configuracion cargada para bus-retrieve-security-notification: {}", domainConfig);
    }

    @Override
    public <T> ApiResponse<T> execute(
        CorrespondenceRequest params,
        Class<T> responseType
    ) {
        String securityNotificationId = params.getId();
        HttpRequest request = HttpRequest.forApiResponse(
                domainConfig.getUrl(),
                HttpRequest.HttpMethod.GET,
                responseType
            )
            .withPathParams(params.toParams())
            .withQueryParams(params.toQueryString())
            .withTimeout(
                domainConfig.getTimeout().getConnect(),
                domainConfig.getTimeout().getResponse()
            );

        try {
            ApiResponse<T> response = httpClientUseCase.executeApiResponse(request);

            log.info(
                "Solicitud del api de dominio exitoso: {}",
                response.getStatusResponse()
            );

            return response;
        } catch (HttpApiResponseException e) {
            log.error(
                "Error HTTP con ApiResponse consultando transaccion {}: {}",
                securityNotificationId,
                e.getApiResponse()
            );

            throw new HttpStatusCodeException(
                e.getStatusCode(),
                e.getApiResponse().getStatusResponse().getStatusCode()
            );
        } catch (HttpStatusCodeException e) {
            log.error(
                "Error HTTP consultando transaccion {}: {} - {}",
                securityNotificationId,
                e.getStatusCode(),
                e.getMessage()
            );

            throw e;
        } catch (Exception e) {
            log.error("Error consultando transaccion {}: {}", securityNotificationId, e.getMessage());
            throw HttpStatusCodeException.serviceUnavailable("503");
        }
    }
}